/*jslint browser: true, indent : 2, maxerr : 50, nomen : true, regexp : true,
sloppy : true */
/*global define: false, $: false, document: false, require: false */

define([], function () {
  "use strict";

  var start = function () {
    require(['i18next', 'jio', 'jquery', 'jqm', 'overrides', 'text', 'renderjs'],
      function (i18n) {

        var fauna = {},         // application environment (PUBLIC-settings)
            flora = {           // user environment (PRIVATE)
              items_good_until: new Date("March 20, 2013 00:00:00")
            },
            util = {}           // utility functions (PUBLIC)

       util = {
            // spinner
            spin : function (what){
              if ( what == "show"){
                $.mobile.showPageLoadingMsg();
              } else {
                $.mobile.hidePageLoadingMsg()
              }
            },

            // screen size small/medium/large
            framer: function () {
              var self = this, frame;
              if ($.mobile.media("screen and (max-width:480px)") || ($.mobile.browser.ie && $(window).width() < 480 )) {
                fauna.screensize = "small";
              } else if ($.mobile.media("screen and (min-width:768px)") || ($.mobile.browser.ie && $(window).width() >= 768 )) {
                fauna.screensize = "large";
              } else {
                fauna.screensize = "medium";
              }
            return fauna.screensize;
            },

            // ajax content
            ajaxContent : function (ajaxObject) {
              var target = ajaxObject.target;
              $.ajax({
                async: true,
                type: 'GET',
                returnFormat: 'json',
                dataType: 'text',
                data: {
                  value: ajaxObject.param1,
                  type:  ajaxObject.param2
                },
                url: ajaxObject.url,
                timeout: 25000,
                success: function(data, target) {
                  ajaxObject.successHandler(JSON.parse(data), ajaxObject.target)
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                  ajaxObject.errorHandler(XMLHttpRequest, textStatus, errorThrown);
                  $.mobile.loading('hide');
                }
              });
            },
 
            // ajax forms
            ajaxFormSubmit : function (ajaxObject) {
              var target = ajaxObject.target;
              $.ajax({
                headers: { "cache-control": "no-cache" },
                async: false,
                type: ajaxObject.type == "" ? "get" : ajaxObject.type,
                url: ajaxObject.url,
                data: ajaxObject.formdata,
                dataType: ajaxObject.returnformat,
                success: function(data){
                  ajaxObject.handleDataInResponse  === "true" ? ajaxObject.successHandler(data) : successHandler();
                },
                error: function (jqXHR, XMLHttpRequest, textStatus, errorThrown) { 
                  //
                }
              });
            },

            // resize buttons labelled with scale-a/div/input
            scale: function () {
              if(util.framer() === "small") {
                $(".scale-a, .scale-div .ui-btn").add( $(".scale-input").closest('.ui-btn') )
                  .filter(':not(.noScale)')
                    .removeClass('ui-btn-icon-left ui-btn-icon-right ui-btn-icon-top ui-btn-icon-bottom')
                    .attr('data-iconpos','notext')
                    .addClass('ui-btn-icon-notext');

              } else {
                $(".scale-a, .scale-div .ui-btn").add( $(".scale-input").closest('.ui-btn') ).each(function() {
                  $(this)
                    .removeClass('ui-btn-icon-notext')
                    .removeAttr('data-iconpos')
                    .addClass('ui-btn-icon-'+($(this).jqmData('iconpos') || 'left'));
                });
              }
            }
          };

// ===========================================================

        // global page handling
        $(document).on('pagecreate', 'div:jqmData(role="page")', function() {

          var widgetsForThisRequest = [
            "text!../gadgets/pageheader.html",
            "text!../gadgets/pagefooter.html"
          ],
            target = [$('head'),$('body')],
            page = $(this);
//             ajaxObject = {}

//           // initialize jio_config
//           if (fauna.jio_base_config === undefined) {
//             // initialize jio
//             fauna.jio_config = jIO.newJio({
//               "type": "local",
//               "username": "app_config",
//               "application_name": "cloudquote"
//             });
// 
//             // request base configuration
//             ajaxObject = {
//               url: "data/app_config.json",
//               target: "",
//               param1: null,
//               param2: null,
//               successHandler : function (data, target) {},
//               errorHandler : function (XMLHttpRequest, textStatus, errorThrown) {}
//             };
//             util.ajaxContent(ajaxObject);
//           }

          // <head>/page footer on first page
          if (fauna.anchor_page === undefined) {
            fauna.anchor_page = page.attr('id');
            require( widgetsForThisRequest,
              function( /* dynamic */ ) {
                var i, widget, template_target;

                for ( i = 0; i < widgetsForThisRequest.length; i++){
                  template_target = target[i];
                  // if customization based on user data required (add logo/img urls, etc)
                  // it should be done here with widget being a string that can be 
                  // modified with replace method
                  widget = arguments[i];
                  template_target.append( widget );
                }
              });
          }

          // initialize renderjs
          RenderJs.init();
        })

        // reset gadgets on pages that are being removed
        .on('pageremove', 'div:jqmData(role="page")', function() {
          $(this).find("[data-gadget]").each(function(){
            if (!$(this).is('.main-interactor')) {
              RenderJs.GadgetIndex.getGadgetById($(this).attr('id')).remove();
            }
          });
        })
        

        // enhancing gadgets when everyone else is done
        .on('render_enhance', function(e, data) {
          var timer;
          data.gadget.trigger("create");
          // controlgroups inside popups
          // this is a JQM controlgroup problem. Controlgroups include other widgets,
          // so they are enhanced last after everything else has been enhanced.
          // when inserting items dynamically and calling create, all widgets get 
          // enhanced, except for controlgroups which somestimes do, sometimes don't
          // work. This is to make sure they work
          // TODO: Find a better way
          if (data.pops) {
            timer = window.setTimeout(function () {
              $('fieldset:jqmData(role="controlgroup")').parent().trigger("create");
              window.clearTimeout(timer);
            },1000);
          }

          // when first gadget is ready, remove the splash scren
          $(window).trigger('initLoaded');
        });


// ===========================================================
        // init application
        if ($.mobile.autoInitializePage === false){
          $.mobile.initializePage();
        }
        $(window).on('initLoaded', function(){
          // remove splash image
          $('html').removeClass('render').find('body').removeClass('splash');
        })
        .on('orientationchange resize', function(){
          // responsive element handling & initial trigger
          util.scale();
        }).trigger('resize');

        // expose public elements
        $.fn.util = util;
        $.fn.fauna = fauna;
      });
  };
  return {"start": start};
});