define([
    'text!../gadgets/modules/mapper.html!strip'
  , 'css!../css/modules/mapper'
  ],
  function (source) {
    var response = {};

    response.data = source;
    response.callback = function () {
      $(document).ready(function() {
        var gadget = RenderJs.getSelfGadget();

        require(['gmaps'], function (gmap) {
              var storedmap,
                target_destination,
                lat = 50.659963,
                lng = 3.098745,
                str = lat+','+lng,
                home = new google.maps.LatLng(lat, lng);

              if (gadget.maps_defined === undefined) {
                $('#map_canvas_1')
                  .gmap({'center': home, 'zoom':17 })
                  .gmap('addMarker', { 'id':'nexedi', 'position': str, 'bound':false, 'animation' : google.maps.Animation.DROP },
                    function(map, marker) {
                      var location = marker.getPosition(),
                      storedmap = map;
                      $('#map_canvas_1').gmap('search', {'location': location}, function(results, status) {
                        target_destination = results[0];
                        $('#to').val(target_destination.formatted_address); 
                      })
                    });
                gadget.maps_defined = true;
              }

              gadget.dom.on('click', '#submit', function () {
                var latlng, cM;
                // get current position
                $('#map_canvas_1').gmap('getCurrentPosition', function(position, status) {
                  if (status === 'OK') {
                    $.mobile.showPageLoadingMsg();
                    // get address
                    latlng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                    $('#map_canvas_1').gmap('search', {'location': latlng}, function(results, status) {
                      origin_destination = results[0];
                      $('#from').val(origin_destination.formatted_address);

                      // get directions
                      $('#map_canvas_1').gmap(
                        'displayDirections',
                        {'origin': $('#from').val(), 'destination': $('#to').val(), 'travelMode': google.maps.DirectionsTravelMode.DRIVING },
                        {'panel': document.getElementById('directions')},
                        function(response, status) {
                          $('#results').show();
                          $.mobile.hidePageLoadingMsg();
                        });
                      }
                    );
                  } else {
                    $('#results').hide();
                    cM = 'unable to localize - please try entering a location manually';

                    $("<div id='notification' class='ui-loader ui-overlay-shadow ui-body-e ui-corner-all'><h1>"+cM+"</h1></div>")
                      .css({ "display": "block", "opacity": 0.96, "top": $(window).scrollTop() + 200})
                      .appendTo( $.mobile.pageContainer )
                      .delay( 400 ) 
                      .fadeOut( 800, function(){
                        $(this).remove();
                      });
                  }
                });
              }); // end click

          });
        $(this).trigger("render_enhance", {gadget: gadget.dom});
      });
    };
  // return response object
  return response;
  }
);